package example.servlet;

import example.entity.UserCredential;

import javax.annotation.Resource;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.EntityManager;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;
import java.io.IOException;
import java.io.PrintWriter;

public class UpdateServlet extends HttpServlet {

    // this injects the default entity manager factory
    @PersistenceUnit(unitName = "pujavaee" )
    private EntityManagerFactory emf;
	
    @Resource
    private UserTransaction utx;
	

    public void service ( HttpServletRequest req , HttpServletResponse resp)
        throws ServletException, IOException {


        EntityManager em = emf.createEntityManager();
        try {
            resp.setContentType("text/html");
            PrintWriter out = resp.getWriter();
            out.println("<HTML> <HEAD> <TITLE> Update" +
                        "</TITLE> </HEAD> <BODY BGCOLOR=white>");

            String name = req.getParameter("name");
			String password = req.getParameter("password");
			String updateAction = req.getParameter("updateAction");

            
			// Do a db look up in example.entity.UserCredential table with the name as the PK
            utx.begin();
            em.joinTransaction();
            out.println("User with name:" + name + "....<p>");
			UserCredential credential = em.find(UserCredential.class, name);
			if("DELETE".equals(updateAction) ) {
				out.println("Deleting....");
				em.remove(credential);
			} else {
				out.println("Updating password to:" + password);
				credential.setPassword(password);
			}
            utx.commit();
            out.println("<p>Done.</BODY> </HTML> ");
        }  catch (Exception e) {
			throw new ServletException(e);
		} finally {
            // we must close em so that provider can release resources.
            em.close();
        }
    }

    public void  init( ServletConfig config) throws ServletException {
        super.init(config);
//        ServletContext context = config.getServletContext();
//        emf = (EntityManagerFactory) context.getAttribute(ContextListner.ATTRIBUTE_EMF);
//        if(emf == null) {
//            emf = Persistence.createEntityManagerFactory("pu1");
//            context.setAttribute(ContextListner.ATTRIBUTE_EMF, emf);
//
//        }
    }

}
