package example.servlet;

import example.entity.UserCredential;
import example.entity.Employee;
import example.entity.Department;

import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import javax.persistence.EntityManager;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;

public class QueryEmpDeptData extends HttpServlet {

    // this injects the default entity manager factory
    @PersistenceUnit(unitName = "pujavaee")
    private EntityManagerFactory emf;

    public void service ( HttpServletRequest req , HttpServletResponse resp)
        throws ServletException, IOException {


        EntityManager em = emf.createEntityManager();
        try {
            resp.setContentType("text/html");
            PrintWriter out = resp.getWriter();
            out.println("<HTML> <HEAD> <TITLE> Query Emp Dept Data " +
                        "</TITLE> </HEAD> <BODY BGCOLOR=white>");

            int id  = 1; //req.getParameter("name");

            // Do a db look up in example.entity.UserCredential table with the name as the PK
            Employee emp = em.find(Employee.class, id);

            // em.find returns null if not found, hence null check.
            if (emp != null ) {
                out.println("Found employee " + emp);
                out.println("Navigating to detparmtnet..." );
                Department dept = emp.getDepartment();
                out.println("Found Department " + dept);
            } else {
                out.println("Could not find employee with id " + id);
            }
            out.println("</BODY> </HTML> ");
        } finally {

            // we must close em so that provider can release resources.
            em.close();
        }
    }

    public void  init( ServletConfig config) throws ServletException {
        super.init(config);
//        ServletContext context = config.getServletContext();
//        emf = (EntityManagerFactory) context.getAttribute(ContextListner.ATTRIBUTE_EMF);
//        if(emf == null) {
//            emf = Persistence.createEntityManagerFactory("pu1");
//            context.setAttribute(ContextListner.ATTRIBUTE_EMF, emf);
//
//        }
    }

}